<?php
/*
Plugin Name: 垃圾评论清理器
Plugin URI: http://www.naks.cn/blueven/?p=244
Description: 清理数据库中被标记为“spam”的评论，给数据库“瘦身”。
Version: 0.1
Author: Ven
Author URI: http://www.naks.cn/blueven/
*/
function ven_spam_cleaner() {
	global $wpdb;
	function byte_conv($val, $input_unit, $precision=2, $output_unit=null) {
		$multi=array(
		'B'=>1,
		'KB'=>1024,
		'MB'=>1024*1024,
		'GB'=>1024*1024*1024,
		'TB'=>1024*1024*1024*1024);
		$input_unit=strtoupper($input_unit);
		$output_unit=strtoupper($output_unit);
		$input_val=$val * $multi[$input_unit];
		reset($multi);
		while (list($key,$value)=each($multi)) {
			if ($key==$output_unit) {
				$output_val=$input_val / $multi[$output_unit];
				break;
			}
			if ($input_val > $value / 10 && $input_val < $value * 100) {
				$output_val=$input_val / $multi[$key];
				$output_unit=$key;
				break;
			}
		}
		return round($output_val,$precision).$output_unit;
	}
	if (!empty($_POST['ven_spam_cleaner_clean'])) {
		$wpdb->query("delete from $wpdb->comments where comment_approved = 'spam'");
	}
	$query="select count(comment_ID) as rows from $wpdb->comments where comment_approved = 'spam'";
	$spam = $wpdb->get_var($query);
	if ($spam != 0) {		
		$result=$wpdb->get_results("show table status");
		$count=count($result);
		for ($i=0; $i<$count; $i++) {
			if ($result[$i]->Name==$wpdb->comments) {
				$spam_length=$result[$i]->Avg_row_length * $spam;
				$spam_length=byte_conv($spam_length,'b');
			}
		}
	}
	?>
	<div class="wrap">
	<h2>垃圾评论清理器</h2>
	<?php
	if ($spam['rows']==0) {
		echo '<p>太棒了，您的数据库中没有垃圾评论！</p>';
	}
	else {
		?>
		<p>数据库中共保存了<?php echo $spam ?>条垃圾评论，总容量约<?php echo $spam_length ?></p>
		<form id="form1" name="form1" method="post" action="">
  		<input type="submit" name="ven_spam_cleaner_clean" value="删除全部垃圾评论" />
		</form>
		<?php
	}
	?>
	</div>
	<?php
}
function wp_ven_spam_cleaner_admin(){
	add_options_page('垃圾评论清理器', '垃圾评论清理器', 5,  __FILE__, 'ven_spam_cleaner');
}

add_action('admin_menu', 'wp_ven_spam_cleaner_admin');
?>